﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.MetaOptimization {
  public delegate void MutateDelegate(IRandom random, IOptimizable configuartion, ParameterConfigurationManipulator pcmanip);
  public delegate void CrossDelegate(IRandom random, IOptimizable configuartion, ParameterConfigurationCrossover pccross);

  public interface IOptimizable : IItem {
    bool IsOptimizable { get; }
    bool Optimize { get; set; }
    ConstrainedValue ActualValue { get; set; }
    
    void Randomize(IRandom random);
    void Mutate(IRandom random, MutateDelegate mutate, ParameterConfigurationManipulator pcmanip);
    void Cross(IRandom random, IOptimizable other, CrossDelegate cross, ParameterConfigurationCrossover pccross);
    
    event EventHandler IsOptimizableChanged;
    event EventHandler OptimizeChanged;
  }
}
